unit uSetup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ComCtrls, ExtCtrls;

type
  TfrmSetup = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    TrackBar: TTrackBar;
    lSpeed: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    Loading : Boolean;
  public
    { Public declarations }
  end;

var
  frmSetup: TfrmSetup;

implementation

uses
  uScreenSaver, uGlobals;

{$R *.DFM}

procedure TfrmSetup.FormCreate(Sender: TObject);
begin
  Loading := True;
  ReadINIFile;
end;

procedure TfrmSetup.FormActivate(Sender: TObject);
begin
  if Loading then begin
    Loading := False;
  end;
end;

procedure TfrmSetup.OKButtonClick(Sender: TObject);
begin
  Interval := (60-TrackBar.Position) * 1000;
  WriteINIFile;
  Close;
end;

procedure TfrmSetup.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmSetup.TrackBarChange(Sender: TObject);
begin
  lSpeed.Caption := 'Cycle Speed ('+IntToStr(60-TrackBar.Position)+' seconds)';
end;

procedure TfrmSetup.FormShow(Sender: TObject);
begin
   TrackBar.Position := 60-(Interval div 1000);
end;

end.

